/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (3.1.2).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package org.openapitools.v1_0.api;

import org.openapitools.v1_0.model.*;
import io.swagger.annotations.*;
import org.openapitools.v1_0.model.Error;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;
import java.util.Optional;
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2023-12-28T14:20:53.221Z[GMT]")

@Validated
@Api(value = "workflow", description = "the workflow API")
public interface WorkflowApi {

    default Optional<NativeWebRequest> getRequest() {
        return Optional.empty();
    }

    @ApiOperation(value = "Deletes cron job", nickname = "deleteCronWorkflow", notes = "Deletes the session's cronjob of the given workflow name.", tags={ "workflow", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success"),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/workflow/{workflowName}/deletecron/{id}",
        produces = { "application/json" }, 
        method = RequestMethod.DELETE)
    default ResponseEntity<?> deleteCronWorkflow(@ApiParam(value = "The workflow name. This has to be a cron workflow.",required=true) @PathVariable("workflowName") String workflowName,@ApiParam(value = "The session ID.",required=true) @PathVariable("id") String id) {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Deletes latest stage of a session for the given sessionId.", nickname = "deleteLatestStage", notes = "Deletes the latest stage of the staginghistory for the given sessionId.", tags={ "workflow", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success"),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/workflow/{id}/deletelatest",
        produces = { "application/json" }, 
        method = RequestMethod.DELETE)
    default ResponseEntity<?> deleteLatestStage(@ApiParam(value = "Id of the session.",required=true) @PathVariable("id") String id) {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Return the status of the workflow given by the given jobId.", nickname = "getWorkflowStatus", notes = "Return the status of the workflow given by the given jobId.", response = Job.class, tags={ "workflow", })
    @ApiResponses(value = { 
        @ApiResponse(code = 404, message = "There is no workflow with that job ID.", response = Error.class),
        @ApiResponse(code = 200, message = "Success.", response = Job.class) })
    @RequestMapping(value = "/workflow/{workflowName}/run/{jobId}/",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    @CrossOrigin
    default ResponseEntity<?> getWorkflowStatus(@ApiParam(value = "The workflow name",required=true) @PathVariable("workflowName") String workflowName,@ApiParam(value = "The job ID.",required=true) @PathVariable("jobId") String jobId) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    ApiUtil.setExampleResponse(request, "application/json", "{  \"startTime\" : \"startTime\",  \"id\" : \"id\",  \"endTime\" : \"endTime\",  \"timeLeftMinutes\" : \"timeLeftMinutes\",  \"logs\" : \"logs\",  \"status\" : \"status\"}");
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Returns all available workflows.", nickname = "getWorkflows", notes = "Returns all available workflows.", response = WorkflowList.class, tags={ "workflow", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success.", response = WorkflowList.class) })
    @RequestMapping(value = "/workflow",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    default ResponseEntity<?> getWorkflows() {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    ApiUtil.setExampleResponse(request, "application/json", "{  \"customWorkflows\" : [ {    \"workflowName\" : \"workflowName\",    \"workflowVersion\" : \"workflowVersion\"  }, {    \"workflowName\" : \"workflowName\",    \"workflowVersion\" : \"workflowVersion\"  } ],  \"integratedWorkflows\" : [ {    \"workflowName\" : \"workflowName\",    \"workflowVersion\" : \"workflowVersion\"  }, {    \"workflowName\" : \"workflowName\",    \"workflowVersion\" : \"workflowVersion\"  } ]}");
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Stores docker image tag for a workflow name.", nickname = "registerWorkflow", notes = "Allows users to register their own docker images as workflows. The service returns  an object containing the resulting name. If a workflow with this name does not exist yet, then the name returned is the name given with \"_v1\" postfix to indicate it is the first version. If additional workflow are added with the same base name, the workflow will not be overwritten. Instead the last version stored will be determined and the new worklow will will be stored with an incremented version from the last version. To run the workflow just registered, the user must use the name that is returned by this end point (including the version).", response = InlineResponse200.class, tags={ "workflow", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success.", response = InlineResponse200.class),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/workflow/register/",
        produces = { "application/json" }, 
        method = RequestMethod.PUT)
    default ResponseEntity<?> registerWorkflow(@NotNull @ApiParam(value = "The workflow name.", required = true) @Valid @RequestParam(value = "workflowName", required = true) String workflowName,@ApiParam(value = "") @Valid @RequestParam(value = "imageTag", required = false) String imageTag) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    ApiUtil.setExampleResponse(request, "application/json", "{  \"workflowName\" : \"workflowName\",  \"imageTag\" : \"imageTag\"}");
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Runs the specified workflow on a work space (notebook)", nickname = "runWorkflow", notes = "Runs a workflow of the type specified as workflowName in the call. Currently supported workflows are 'download', 'wow', 'knmidataplatform', 'opendap' and 'rookwps'. Both require a CWL input file in base64 encoded form.", response = Job.class, tags={ "workflow", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success", response = Job.class),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/workflow/{workflowName}/run/",
        produces = { "application/json" }, 
        consumes = { "application/json", "application/xml" },
        method = RequestMethod.POST)
    @CrossOrigin
    default ResponseEntity<?> runWorkflow(@ApiParam(value = "The workflow name.",required=true) @PathVariable("workflowName") String workflowName,@ApiParam(value = "Workflow." ,required=true )  @Valid @RequestBody Workflow workflow) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    ApiUtil.setExampleResponse(request, "application/json", "{  \"startTime\" : \"startTime\",  \"id\" : \"id\",  \"endTime\" : \"endTime\",  \"logs\" : \"logs\",  \"status\" : \"status\"}");
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }

}
